//---
#define server_flags FILE_WRITE|FILE_SHARE_WRITE|FILE_SHARE_READ|FILE_COMMON|FILE_BIN
#define client_flags FILE_READ|FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_COMMON|FILE_BIN
#define program MQLInfoString(MQL_PROGRAM_NAME)
#define ask tick.ask
#define bid tick.bid
//---
#define _debug
//---
enum Mode {
    Server, Client
};

enum Set {};
sinput Set;// === settings ===
sinput Mode mode = Server;
sinput string server_id = "LetCashFlow";
sinput double copy_factor = 100;
//---
static ulong open_tickets[], expired_tickets[];
//---
struct pair_ticket {
    ulong            sr_ticket, cl_ticket;
                     pair_ticket(void):
                     sr_ticket(0), cl_ticket(0) {};
};
//---
static int fhandle = INVALID_HANDLE;
const string fname = "Server++/" + server_id;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit() {
    return INIT_FAILED;
    if(mode == Server) {
        if(FileIsExist("Server++/delete", FILE_COMMON))
            if(!FileDelete("Server++/delete", FILE_COMMON)) {
                Alert("Server error!");
                return 97;
            }
        if(FileIsExist(fname, FILE_COMMON))
            if(!FileDelete(fname, FILE_COMMON)) {
                Alert(StringFormat("Please terminate the server instance at [%s] and try again!", server_id));
                return 98;
            }
        //---
        fhandle = FileOpen(fname, server_flags);
        if(fhandle == INVALID_HANDLE) {
            Alert(StringFormat("Failed setting up server at address [%s]", server_id));
            return 99;
        }
    } else {
        if(FileIsExist("Server++/delete", FILE_COMMON))
            if(!FileDelete("Server++/delete", FILE_COMMON)) {
                Alert("Server error!");
                return 100;
            }
        int error = 0;
        if(!reconnect(server_id, error))
            return error;
    }
#ifndef _debug
    Alert(StringFormat("%s launched successfully!", EnumToString(mode)));
#endif
//---
//---
#ifdef _debug
    EventSetTimer(1);
#endif
//---
    return 0;
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {
    Comment("");
    FileClose(fhandle);
    Print(StringFormat("%s shutting down...", EnumToString(mode)));
    if(mode == Server)
        if(!FileDelete(fname, FILE_COMMON)) {
            int del = FileOpen("Server++/delete", FILE_BIN | FILE_COMMON | FILE_WRITE);
            if(del == INVALID_HANDLE) {
                Alert("Server abnormal shutdown!");
                return;
            }
            FileWriteDouble(del, 3.142);
            FileFlush(del);
            FileClose(del);
            printf("Preparing termination of clients...");
            printf("%s shutdown successfull.",  EnumToString(mode));
            return;
        }
    if(mode == Client) {
        if(FileIsExist("Server++/delete", FILE_COMMON))
            if(FileDelete(fname, FILE_COMMON))
                if(!FileDelete("Server++/delete", FILE_COMMON)) {
                    Alert("Please clear common folder manually!");
                    return;
                }
        printf("%s shutdown successfull.", EnumToString(mode));
        return;
    }
    return;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTimer(void) {
    OnTick();
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct Data {
    ulong            ticket;
    double           lotsize, sl, tp;
    double           open_price;
    uchar            symbol[8];
    uchar            salt_set[32];
                     Data(void): ticket(0), lotsize(0.0), sl(0.0),
                     tp(0.0), open_price(0.0) {
        ArrayInitialize(salt_set, NULL);
        ArrayInitialize(symbol, NULL);
    }
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void) {
#ifndef _debug
    if(!TradeAllowed())
        return;
#endif
//---   check if server is active
    int error = NULL;
    if(mode == Client)
        if(FileIsExist("Server++/delete", FILE_COMMON)) {
            Alert("Server disconnected!");
            ExpertRemove();
            return;
        }
//--- run server or client loop
//--- skip odd ticks. Can be commented out
    ulong count = 0;
    if(count % 1 == 0)
        return;
//---
    if(mode == Server) {
    } else if(mode == Client) {
        Data dt;
        int data_size = sizeof(Data);
        FileReadStruct(fhandle, dt, data_size);
        if(dt.ticket == 0)
            return;
        //---
        string received = StringFormat("Ticket: %d\nSymbol: %s\nVolume:"
                                       " %f\nSl: %f\nTp: %f", dt.ticket,
                                       CharArrayToString(dt.symbol, 0, 8),
                                       dt.lotsize, dt.sl, dt.tp);
        Comment(received);
    }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//|                      Utility Tools                               |
//+------------------------------------------------------------------+
template <typename t>
int malloc(t &array[], const int size, const int reserved = 0) {
    return ArrayResize(array, size, reserved);
}
//---
template <typename t>
void append(t &array[], const t &element) {
    int size = ArraySize(array);
    int reserved = 0;
    if(size % 10 == 0)
        reserved = 10;
    ArrayResize(array, size + 1, reserved);
    array[size] = element;
}
//---
template <typename t>
bool pop(t &array[], const t element) {
    int counter = len(array);
    while(counter) {
        int idx = present(array, element);
        if(idx == -1)break;
        ArrayRemove(array, idx, 1);
        --counter;
    }
    return present(array, element) == -1;
}
//---
template <typename t>
int present(const t &array[], const t element) {
    for(int i = 0; i < len(array); i++)
        if(array[i] == element)
            return i;
    return -1;
}
//---
template <typename t>
int len(const t &array[]) {
    return ArraySize(array);
}
//---
int len(const string var) {
    return StringLen(var);
}
//---
double VerifyLots(double variable) {
    double volume = NormalizeDouble(variable, 2);
    double lots_step = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_STEP);
    if(lots_step > 0.0)
        volume = lots_step * MathFloor(volume / lots_step);
    double lots_min = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MIN);
    if(volume < lots_min)
        volume = 0.0;
    double lots_max = SymbolInfoDouble(Symbol(), SYMBOL_VOLUME_MAX);
    if(volume > lots_max)
        volume = lots_max;
    return(volume);
}
//---
bool TradeAllowed(void) {
    return AccountInfoInteger(ACCOUNT_TRADE_ALLOWED) &&
           AccountInfoInteger(ACCOUNT_TRADE_EXPERT) &&
           TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) &&
           TerminalInfoInteger(TERMINAL_CONNECTED);
}
//---
bool reconnect(const string sr_id, int &err) {
    if(mode != Client)
        return false;
    if(!FileIsExist(fname, FILE_COMMON)) {
        Alert(StringFormat("No server at specified address [%s]!", server_id));
        err = 100;
        return false;
    }
    if(FileIsExist("Server++/delete", FILE_COMMON))
        return false;
    fhandle = FileOpen(fname, client_flags);
    if(fhandle == INVALID_HANDLE) {
        Alert(StringFormat("Failed setting up client at address [%s]", server_id));
        {
            err = 101;
            return false;
        }
    }
    if(FileSize(fhandle) > 0)
        if(!FileSeek(fhandle, 0, SEEK_END)) {
            Alert("Server error!");
            err = 102;
            return false;
        }
    return true;
}
//+------------------------------------------------------------------+
